# coding: utf-8

# flake8: noqa

"""
    GoodMem API

    API for interacting with the GoodMem service, providing vector-based memory storage and retrieval with multiple embedder support. The service enables creation of memory spaces, storing memories with vector representations, and efficient similarity-based retrieval.

    The version of the OpenAPI document: v1
    Contact: support@goodmem.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from goodmem_client.api.api_keys_api import APIKeysApi
from goodmem_client.api.embedders_api import EmbeddersApi
from goodmem_client.api.memories_api import MemoriesApi
from goodmem_client.api.spaces_api import SpacesApi
from goodmem_client.api.system_api import SystemApi
from goodmem_client.api.users_api import UsersApi

# import ApiClient
from goodmem_client.api_response import ApiResponse
from goodmem_client.api_client import ApiClient
from goodmem_client.configuration import Configuration
from goodmem_client.exceptions import OpenApiException
from goodmem_client.exceptions import ApiTypeError
from goodmem_client.exceptions import ApiValueError
from goodmem_client.exceptions import ApiKeyError
from goodmem_client.exceptions import ApiAttributeError
from goodmem_client.exceptions import ApiException

# import models into sdk package
from goodmem_client.models.api_key_response import ApiKeyResponse
from goodmem_client.models.batch_memory_creation_request import BatchMemoryCreationRequest
from goodmem_client.models.batch_memory_deletion_request import BatchMemoryDeletionRequest
from goodmem_client.models.batch_memory_retrieval_request import BatchMemoryRetrievalRequest
from goodmem_client.models.create_api_key_request import CreateApiKeyRequest
from goodmem_client.models.create_api_key_response import CreateApiKeyResponse
from goodmem_client.models.embedder_creation_request import EmbedderCreationRequest
from goodmem_client.models.embedder_response import EmbedderResponse
from goodmem_client.models.list_api_keys_response import ListApiKeysResponse
from goodmem_client.models.list_embedders_response import ListEmbeddersResponse
from goodmem_client.models.list_spaces_response import ListSpacesResponse
from goodmem_client.models.memory import Memory
from goodmem_client.models.memory_creation_request import MemoryCreationRequest
from goodmem_client.models.memory_list_response import MemoryListResponse
from goodmem_client.models.modality import Modality
from goodmem_client.models.provider_type import ProviderType
from goodmem_client.models.space import Space
from goodmem_client.models.space_creation_request import SpaceCreationRequest
from goodmem_client.models.system_init_response import SystemInitResponse
from goodmem_client.models.update_api_key_request import UpdateApiKeyRequest
from goodmem_client.models.update_embedder_request import UpdateEmbedderRequest
from goodmem_client.models.update_space_request import UpdateSpaceRequest
from goodmem_client.models.user_response import UserResponse
