# coding: utf-8

"""
    GoodMem API

    API for interacting with the GoodMem service, providing vector-based memory storage and retrieval with multiple embedder support. The service enables creation of memory spaces, storing memories with vector representations, and efficient similarity-based retrieval.

    The version of the OpenAPI document: v1
    Contact: support@goodmem.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from goodmem_client.models.space import Space
from typing import Optional, Set
from typing_extensions import Self

class ListSpacesResponse(BaseModel):
    """
    Response containing a list of spaces and optional pagination token.
    """ # noqa: E501
    spaces: Optional[List[Space]] = Field(default=None, description="The list of spaces matching the query criteria.")
    next_token: Optional[StrictStr] = Field(default=None, description="Pagination token for retrieving the next set of results. Only present if there are more results available.", alias="nextToken")
    __properties: ClassVar[List[str]] = ["spaces", "nextToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListSpacesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in spaces (list)
        _items = []
        if self.spaces:
            for _item_spaces in self.spaces:
                if _item_spaces:
                    _items.append(_item_spaces.to_dict())
            _dict['spaces'] = _items
        # set to None if next_token (nullable) is None
        # and model_fields_set contains the field
        if self.next_token is None and "next_token" in self.model_fields_set:
            _dict['nextToken'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListSpacesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "spaces": [Space.from_dict(_item) for _item in obj["spaces"]] if obj.get("spaces") is not None else None,
            "nextToken": obj.get("nextToken")
        })
        return _obj


